"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _clsx = _interopRequireDefault(require("clsx"));

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _fnToString = _interopRequireDefault(require("../utils/fn-to-string"));

var _reducer = _interopRequireDefault(require("./reducer"));

var _useIsMounted = _interopRequireDefault(require("../hooks/use-is-mounted"));

/* eslint-disable react-hooks/exhaustive-deps */
var getSelectValue = function getSelectValue(stateValue, simpleValue, isMulti, allOptions) {
  return simpleValue ? allOptions.filter(function (_ref) {
    var value = _ref.value;
    return isMulti ? stateValue.includes(value) : (0, _isEqual["default"])(value, stateValue);
  }) : stateValue;
};

var handleSelectChange = function handleSelectChange(option, simpleValue, isMulti, onChange) {
  var sanitizedOption = !option && isMulti ? [] : option;
  return simpleValue ? onChange(isMulti ? sanitizedOption.map(function (item) {
    return item.value;
  }) : sanitizedOption ? sanitizedOption.value : undefined) : onChange(sanitizedOption);
};

var Select = function Select(_ref2) {
  var invalid = _ref2.invalid,
      classNamePrefix = _ref2.classNamePrefix,
      simpleValue = _ref2.simpleValue,
      isMulti = _ref2.isMulti,
      pluckSingleValue = _ref2.pluckSingleValue,
      propsOptions = _ref2.options,
      loadOptions = _ref2.loadOptions,
      loadingMessage = _ref2.loadingMessage,
      loadingProps = _ref2.loadingProps,
      selectVariant = _ref2.selectVariant,
      updatingMessage = _ref2.updatingMessage,
      noOptionsMessage = _ref2.noOptionsMessage,
      value = _ref2.value,
      _onChange = _ref2.onChange,
      loadOptionsChangeCounter = _ref2.loadOptionsChangeCounter,
      SelectComponent = _ref2.SelectComponent,
      noValueUpdates = _ref2.noValueUpdates,
      props = (0, _objectWithoutProperties2["default"])(_ref2, ["invalid", "classNamePrefix", "simpleValue", "isMulti", "pluckSingleValue", "options", "loadOptions", "loadingMessage", "loadingProps", "selectVariant", "updatingMessage", "noOptionsMessage", "value", "onChange", "loadOptionsChangeCounter", "SelectComponent", "noValueUpdates"]);

  var _useReducer = (0, _react.useReducer)(_reducer["default"], {
    isLoading: false,
    options: propsOptions,
    promises: {},
    isInitialLoaded: false
  }),
      _useReducer2 = (0, _slicedToArray2["default"])(_useReducer, 2),
      state = _useReducer2[0],
      dispatch = _useReducer2[1];

  var isMounted = (0, _useIsMounted["default"])();

  var updateOptions = function updateOptions() {
    dispatch({
      type: 'startLoading'
    });
    return loadOptions().then(function (data) {
      if (isMounted.current) {
        if (!noValueUpdates) {
          if (value && Array.isArray(value)) {
            var _selectValue = value.filter(function (value) {
              return (0, _typeof2["default"])(value) === 'object' ? data.find(function (option) {
                return value.value === option.value;
              }) : data.find(function (option) {
                return value === option.value;
              });
            });

            _onChange(_selectValue.length === 0 ? undefined : _selectValue);
          } else if (value && !data.find(function (_ref3) {
            var internalValue = _ref3.value;
            return internalValue === value;
          })) {
            _onChange(undefined);
          }
        }

        dispatch({
          type: 'updateOptions',
          payload: data
        });
      }
    });
  };

  (0, _react.useEffect)(function () {
    if (loadOptions) {
      updateOptions();
    }

    dispatch({
      type: 'initialLoaded'
    });
  }, []);
  var loadOptionsStr = loadOptions ? (0, _fnToString["default"])(loadOptions) : '';
  (0, _react.useEffect)(function () {
    if (loadOptionsStr && state.isInitialLoaded) {
      updateOptions();
    }
  }, [loadOptionsStr, loadOptionsChangeCounter]);
  (0, _react.useEffect)(function () {
    if (state.isInitialLoaded) {
      if (!noValueUpdates && value && !propsOptions.map(function (_ref4) {
        var value = _ref4.value;
        return value;
      }).includes(value)) {
        _onChange(undefined);
      }

      dispatch({
        type: 'setOptions',
        payload: propsOptions
      });
    }
  }, [propsOptions]);

  var renderNoOptionsMessage = function renderNoOptionsMessage() {
    return Object.values(state.promises).some(function (value) {
      return value;
    }) ? function () {
      return updatingMessage;
    } : function () {
      return noOptionsMessage;
    };
  };

  if (state.isLoading) {
    return /*#__PURE__*/_react["default"].createElement(SelectComponent, (0, _extends2["default"])({}, props, {
      classNamePrefix: classNamePrefix,
      isDisabled: true,
      isFetching: true,
      placeholder: loadingMessage,
      options: state.options,
      onChange: function onChange() {}
    }, loadingProps, {
      noOptionsMessage: renderNoOptionsMessage()
    }));
  }

  var onInputChange = function onInputChange(inputValue) {
    if (inputValue && loadOptions && state.promises[inputValue] === undefined && props.isSearchable) {
      dispatch({
        type: 'setPromises',
        payload: (0, _defineProperty2["default"])({}, inputValue, true)
      });
      loadOptions(inputValue).then(function (options) {
        if (isMounted.current) {
          dispatch({
            type: 'setPromises',
            payload: (0, _defineProperty2["default"])({}, inputValue, false),
            options: options
          });
        }
      })["catch"](function (error) {
        dispatch({
          type: 'setPromises',
          payload: (0, _defineProperty2["default"])({}, inputValue, false)
        });
        throw error;
      });
    }
  };

  var selectValue = pluckSingleValue ? isMulti ? value : Array.isArray(value) && value[0] ? value[0] : value : value;
  return /*#__PURE__*/_react["default"].createElement(SelectComponent, (0, _extends2["default"])({
    className: (0, _clsx["default"])(classNamePrefix, {
      'has-error': invalid
    })
  }, props, {
    isDisabled: props.isDisabled || props.isReadOnly,
    options: state.options,
    classNamePrefix: classNamePrefix,
    isMulti: isMulti,
    value: getSelectValue(selectValue, simpleValue, isMulti, state.options),
    onChange: function onChange(option) {
      return handleSelectChange(option, simpleValue, isMulti, _onChange);
    },
    onInputChange: onInputChange,
    isFetching: Object.values(state.promises).some(function (value) {
      return value;
    }),
    noOptionsMessage: renderNoOptionsMessage(),
    hideSelectedOptions: false,
    closeMenuOnSelect: !isMulti
  }));
};

Select.propTypes = {
  options: _propTypes["default"].array,
  onChange: _propTypes["default"].func,
  classNamePrefix: _propTypes["default"].string,
  invalid: _propTypes["default"].bool,
  simpleValue: _propTypes["default"].bool,
  isMulti: _propTypes["default"].bool,
  pluckSingleValue: _propTypes["default"].bool,
  value: _propTypes["default"].any,
  placeholder: _propTypes["default"].string,
  loadOptionsChangeCounter: _propTypes["default"].number,
  isDisabled: _propTypes["default"].bool,
  isReadOnly: _propTypes["default"].bool,
  loadOptions: _propTypes["default"].func,
  loadingMessage: _propTypes["default"].node,
  loadingProps: _propTypes["default"].object,
  selectVariant: _propTypes["default"].string,
  updatingMessage: _propTypes["default"].node,
  noOptionsMessage: _propTypes["default"].node,
  isSearchable: _propTypes["default"].bool,
  SelectComponent: _propTypes["default"].elementType.isRequired,
  noValueUpdates: _propTypes["default"].bool
};
Select.defaultProps = {
  options: [],
  invalid: false,
  simpleValue: true,
  pluckSingleValue: true,
  placeholder: 'Choose...',
  isSearchable: false,
  isClearable: false
};
var _default = Select;
exports["default"] = _default;